<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Car</h2>
    <p>Select car and car types</p>

    <form id="inputform01" class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="fname" name="firstname" placeholder="Your name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="lname" name="lastname" placeholder="Your last name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" disabled name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row pull-right">
        <div class="col-sm-12">
          <input type="button" value="Send" class="btn btn-info" id="send-button">
        </div>
      </div>
    </form>
  </div>
  <script>
    //Get data country
    $.ajax({
      url: "http://localhost:8080/cars",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToCountrySelect(pObjRes);
      },
      error: function(pXhrObj) {
        console.log(pXhrObj);
      }
    });

    var gCarSelectElement = $("#car-select");

    function loadDataToCountrySelect(pCarList) {
      for (i = 0; i < pCarList.length; i++) {
        var bCarOption = $("<option/>");
        bCarOption.prop("value", pCarList[i].carCode);
        bCarOption.prop("text", pCarList[i].carName);
        gCarSelectElement.append(bCarOption);
      };
    }

    var gTypeSelectElement = $("#car-type-select");

    //callback function
    gCarSelectElement.on("change", function () {
      gTypeSelectElement.html("");
      var bCarCode = $(this).val();

      console.log("Car code is selected: " + bCarCode);
      getRegionsByCountryCode(bCarCode);
    });

    //find brandTypes array by brandId
    function getRegionsByCountryCode(pCarCode) {
      $.ajax({
        url: "http://localhost:8080/car-type?carCode="+pCarCode,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToRegionSelect(pObjRes);
        },
        error: function(pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToRegionSelect(pTypeList) {
      if (pTypeList.length > 0) {
        gTypeSelectElement.prop("disabled", false);

        for (i = 0; i < pTypeList.length; i++) {
          var bTypeOption = $("<option/>");
          bTypeOption.prop("value", pTypeList[i].typeCode);
          bTypeOption.prop("text", pTypeList[i].typeName);
          gTypeSelectElement.append(bTypeOption);
        };
      } else {
        gTypeSelectElement.prop("disabled", "disabled");
      }
    }

  </script>
</body>

</html>